/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.31 Revision 1.54
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.31 2006/09/07 18:49:44 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.54 2008/03/22 18:04:51 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
38# 38#
39# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
41# 41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44# 44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
48 48
58# all patches which ending on diff or patch in this DIR will automatically applied 58# all patches which ending on diff or patch in this DIR will automatically applied
59# 59#
60 60
61inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
62 62
63IUSE="debug" 63IUSE=""
64 64
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
67VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 )
78 >=app-admin/eselect-vdr-0.0.2
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
78 80
79 81
80# this code is from linux-mod.eclass 82# New method of storing plugindb
81update_vdrplugindb() { 83# Called from src_install
84# file maintained by normal portage-methods
85create_plugindb_file() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
88 insinto "${NEW_VDRPLUGINDB_DIR}"
83 89
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 90# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 91# cat <<-EOT > "${D}/${DB_FILE}"
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb 92# VDRPLUGIN_DB=1
93# CREATOR=ECLASS
94# EBUILD=${CATEGORY}/${PN}
95# EBUILD_V=${PVR}
96# EOT
97 {
98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}"
102 } > "${D}/${DB_FILE}"
103}
104
105# Delete files created outside of vdr-plugin.eclass
106# vdrplugin-rebuild.ebuild converted plugindb and files are
107# not deleted by portage itself - should only be needed as
108# long as not every system has switched over to
109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
110delete_orphan_plugindb_file() {
111 #elog Testing for orphaned plugindb file
112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
114
115 # file exists
116 [[ -f ${DB_FILE} ]] || return
117
118 # will portage handle the file itself
119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
120 #elog file owned by eclass - don't touch it
121 return
122 fi
123
124 elog "Removing orphaned plugindb-file."
125 elog "\t#rm ${DB_FILE}"
126 rm "${DB_FILE}"
127}
128
129
130create_header_checksum_file()
131{
132 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway
134
135 insinto "${VDR_CHECKSUM_DIR}"
136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}"
138 else
139 if type -p md5sum >/dev/null 2>&1; then
140 cd "${S}"
141 (
142 cd "${VDR_INCLUDE_DIR}"
143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
144 ) > header-md5-${PN}
145 doins header-md5-${PN}
87 fi 146 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi 147 fi
101} 148}
102 149
103vdr-plugin_pkg_setup() { 150vdr-plugin_pkg_setup() {
104 # -fPIC is needed for shared objects on some platforms (amd64 and others) 151 # -fPIC is needed for shared objects on some platforms (amd64 and others)
105 append-flags -fPIC 152 append-flags -fPIC
106 use debug && append-flags -g
107 153
108 # Where should the plugins live in the filesystem 154 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 155 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 156 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111 157
112 # transition to /usr/share/... will need new vdr-scripts version stable 158 # was /usr/lib/... some time ago
159 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
113 VDR_RC_DIR="/usr/lib/vdr/rcscript" 160 VDR_RC_DIR="/usr/share/vdr/rcscript"
114 161
115 # Pathes to includes 162 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr" 163 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include" 164 DVB_INCLUDE_DIR="/usr/include"
118 165
119 166
167 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
168 LOCDIR="/usr/share/vdr/locale"
169 if has_version ">=media-video/vdr-1.5.7"; then
170 USE_GETTEXT=1
171 else
172 USE_GETTEXT=0
173 fi
174
120 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 175 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
121 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 176 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
122 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 177 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
123 178
124 einfo "Building ${PF} against vdr-${VDRVERSION}" 179 einfo "Building ${PF} against vdr-${VDRVERSION}"
125 einfo "APIVERSION: ${APIVERSION}" 180 einfo "APIVERSION: ${APIVERSION}"
126} 181}
131 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 186 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
132 echo 187 echo
133 eerror "Please report this at bugs.gentoo.org." 188 eerror "Please report this at bugs.gentoo.org."
134 die "vdr-plugin_pkg_setup not called!" 189 die "vdr-plugin_pkg_setup not called!"
135 fi 190 fi
136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 191 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n
137 192
138 while [ "$1" ]; do 193 while [ "$1" ]; do
139 194
140 case "$1" in 195 case "$1" in
196 all_but_unpack)
197 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
198 ;;
141 unpack) 199 unpack)
142 base_src_unpack 200 base_src_unpack
143 ;; 201 ;;
144 patchmakefile) 202 patchmakefile)
145 if ! cd ${S}; then 203 if ! cd "${S}"; then
146 ewarn "There seems to be no plugin-directory with the name ${S##*/}" 204 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
147 ewarn "Perhaps you find one among these:" 205 ewarn "Perhaps you find one among these:"
148 cd "${WORKDIR}" 206 cd "${WORKDIR}"
149 einfo "$(/bin/ls -1 ${WORKDIR})" 207 ewarn "$(/bin/ls -1 "${WORKDIR}")"
150 die "Could not change to plugin-source-directory!" 208 die "Could not change to plugin-source-directory!"
151 fi 209 fi
152 210
153 einfo "Patching Makefile" 211 einfo "Patching Makefile"
154 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 212 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
155 cp Makefile Makefile.orig 213 cp Makefile "${WORKDIR}"/Makefile.before
156 214
157 sed -i Makefile \ 215 sed -i Makefile \
158 -e '1i\#Makefile was patched by vdr-plugin.eclass' 216 -e '1i\#Makefile was patched by vdr-plugin.eclass'
159 217
160 ebegin " Setting Pathes" 218 ebegin " Setting Pathes"
173 -e 's:^APIVERSION = :APIVERSION ?= :' \ 231 -e 's:^APIVERSION = :APIVERSION ?= :' \
174 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \ 232 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
175 -e '2i\APIVERSION = '"${APIVERSION}" 233 -e '2i\APIVERSION = '"${APIVERSION}"
176 eend $? 234 eend $?
177 235
178 ebegin " Correcting CXXFLAGS" 236 ebegin " Correcting Compile-Flags"
237 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
179 sed -i Makefile \ 238 sed -i Makefile \
180 -e 's:^CXXFLAGS:#CXXFLAGS:' 239 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
240 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
181 eend $? 241 eend $?
182 242
183 ebegin " Disabling file stripping" 243 ebegin " Disabling file stripping"
184 sed -i Makefile \ 244 sed -i Makefile \
185 -e '/@.*strip/d' \ 245 -e '/@.*strip/d' \
186 -e '/strip \$(LIBDIR)\/\$@/d' \ 246 -e '/strip \$(LIBDIR)\/\$@/d' \
187 -e '/^STRIP =/d' \ 247 -e '/^STRIP =/d' \
188 -e '/@.*\$(STRIP)/d' 248 -e '/@.*\$(STRIP)/d'
189 eend $? 249 eend $?
250
251 # Use a file instead of an variable as single-stepping via ebuild
252 # destroys environment.
253 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
190 ;; 254 ;;
191 add_local_patch) 255 add_local_patch)
192 cd ${S} 256 cd "${S}"
193 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then 257 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
194 echo 258 echo
195 einfo "Applying local patches" 259 einfo "Applying local patches"
196 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do 260 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
197 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}" 261 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
198 done 262 done
199 fi 263 fi
200 ;; 264 ;;
265 i18n)
266 cd "${S}"
267 if [[ ${USE_GETTEXT} = 0 ]]; then
268 # Remove i18n Target if using older vdr
269 sed -i Makefile \
270 -e '/^all:/s/ i18n//'
271 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
272 einfo "Plugin is not yet changed for new translation system."
273 einfo "Auto converting translations to gettext"
274
275 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
276 if [[ ! -x ${i18n_tool} ]]; then
277 eerror "Missing ${i18n_tool}"
278 eerror "Please re-emerge vdr"
279 die "Missing ${i18n_tool}"
280 fi
281
282 # call i18n-to-gettext tool
283 # take all texts missing tr call into special file
284 "${i18n_tool}" 2>/dev/null \
285 |sed -e '/^"/!d' \
286 -e '/^""$/d' \
287 -e 's/\(.*\)/trNOOP(\1)/' \
288 > dummy-translations-trNOOP.c
289
290 # if there were untranslated texts just run it again
291 # now the missing calls are listed in
292 # dummy-translations-trNOOP.c
293 if [[ -s dummy-translations-trNOOP.c ]]; then
294 "${i18n_tool}" &>/dev/null
295 fi
296
297 # now use the modified Makefile
298 if [[ -f Makefile.new ]]; then
299 mv Makefile.new Makefile
300 else
301 ewarn "Conversion to gettext failed. Plugin needs fixing."
302 fi
303 fi
201 esac 304 esac
202 305
203 shift 306 shift
204 done 307 done
205} 308}
206 309
207vdr-plugin_copy_source_tree() { 310vdr-plugin_copy_source_tree() {
311 pushd . >/dev/null
208 cp -r ${S} ${T}/source-tree 312 cp -r "${S}" "${T}"/source-tree
209 cd ${T}/source-tree 313 cd "${T}"/source-tree
210 mv Makefile.orig Makefile 314 cp "${WORKDIR}"/Makefile.before Makefile
211 sed -i Makefile \ 315 sed -i Makefile \
212 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 316 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
213 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 317 -e 's:^CXXFLAGS:#CXXFLAGS:' \
214 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 318 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
215 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' 319 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
320 popd >/dev/null
216} 321}
217 322
218vdr-plugin_install_source_tree() { 323vdr-plugin_install_source_tree() {
219 einfo "Installing sources" 324 einfo "Installing sources"
220 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN} 325 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
221 insinto ${destdir}-${PV} 326 insinto "${destdir}-${PV}"
222 doins -r ${T}/source-tree/* 327 doins -r "${T}"/source-tree/*
223 328
224 dosym ${VDRPLUGIN}-${PV} ${destdir} 329 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
225} 330}
226 331
227vdr-plugin_src_compile() { 332vdr-plugin_src_compile() {
228 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 333 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
229 334
232 case "$1" in 337 case "$1" in
233 prepare) 338 prepare)
234 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 339 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
235 ;; 340 ;;
236 compile) 341 compile)
342 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
343 eerror "Wrong use of vdr-plugin.eclass."
344 eerror "An ebuild for a vdr-plugin will not work without"
345 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
346 echo
347 eerror "Please report this at bugs.gentoo.org."
348 die "vdr-plugin_src_unpack not called!"
349 fi
237 cd ${S} 350 cd "${S}"
238 351
239 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 352 emake ${BUILD_PARAMS} \
353 ${VDRPLUGIN_MAKE_TARGET:-all} \
354 LOCALEDIR="${TMP_LOCALE_DIR}" \
355 || die "emake failed"
240 ;; 356 ;;
241 esac 357 esac
242 358
243 shift 359 shift
244 done 360 done
245} 361}
246 362
247vdr-plugin_src_install() { 363vdr-plugin_src_install() {
248 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 364 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
249 cd ${S} 365 cd "${WORKDIR}"
250 366
251 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 367 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
252 local mname=${P}-Makefile 368 local mname="${P}-Makefile"
253 cp Makefile ${mname}.patched 369 cp "${S}"/Makefile "${mname}.patched"
254 cp Makefile.orig ${mname}.before 370 cp Makefile.before "${mname}.before"
255 371
256 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 372 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
257 373
258 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 374 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
259 doins ${mname}.diff 375 doins "${mname}.diff"
260 376
261 insinto "/usr/share/vdr/maintainer-data/makefile-before" 377 insinto "/usr/share/vdr/maintainer-data/makefile-before"
262 doins ${mname}.before 378 doins "${mname}.before"
263 379
264 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 380 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
265 doins ${mname}.patched 381 doins "${mname}.patched"
266 382
267 fi 383 fi
268 384
385 cd "${S}"
269 insinto "${VDR_PLUGIN_DIR}" 386 insinto "${VDR_PLUGIN_DIR}"
270 doins libvdr-*.so.* 387 doins libvdr-*.so.*
388
389 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then
390 einfo "Installing locales"
391 cd "${TMP_LOCALE_DIR}"
392 insinto "${LOCDIR}"
393 doins -r *
394 fi
395
396 cd "${S}"
271 local docfile 397 local docfile
272 for docfile in README* HISTORY CHANGELOG; do 398 for docfile in README* HISTORY CHANGELOG; do
273 [[ -f ${docfile} ]] && dodoc ${docfile} 399 [[ -f ${docfile} ]] && dodoc ${docfile}
274 done 400 done
275 401
276 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 402 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
277 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 403 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
278 404
279 if [[ -n ${VDR_CONFD_FILE} ]]; then 405 if [[ -n ${VDR_CONFD_FILE} ]]; then
280 insinto /etc/conf.d
281 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 406 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
282 fi 407 fi
283 408
284 409
285 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 410 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
286 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 411 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
288 if [[ -n ${VDR_RCADDON_FILE} ]]; then 413 if [[ -n ${VDR_RCADDON_FILE} ]]; then
289 insinto "${VDR_RC_DIR}" 414 insinto "${VDR_RC_DIR}"
290 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 415 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
291 fi 416 fi
292 417
418 create_header_checksum_file
419 create_plugindb_file
420}
293 421
294 422vdr-plugin_print_enable_command() {
295 insinto ${VDR_CHECKSUM_DIR} 423 elog
296 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 424 elog "To activate this vdr-plugin execute the following command:"
297 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 425 elog "\teselect vdr-plugin enable ${PN#vdr-}"
298 else 426 elog
299 if which md5sum >/dev/null 2>&1; then
300 cd ${S}
301 (
302 cd ${ROOT}${VDR_INCLUDE_DIR}
303 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
304 ) > header-md5-${PN}
305 doins header-md5-${PN}
306 fi
307 fi
308} 427}
309 428
310vdr-plugin_pkg_postinst() { 429vdr-plugin_pkg_postinst() {
311 update_vdrplugindb 430 vdr-plugin_print_enable_command
312 einfo 431
313 einfo "The vdr plugin ${VDRPLUGIN} has now been installed."
314 einfo "To activate execute the following command:"
315 einfo
316 einfo " emerge --config ${PN}"
317 einfo
318 if [[ -n "${VDR_CONFD_FILE}" ]]; then 432 if [[ -n "${VDR_CONFD_FILE}" ]]; then
319 einfo "And have a look at the config-file" 433 elog "Please have a look at the config-file"
320 einfo "/etc/conf.d/vdr.${VDRPLUGIN}" 434 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
321 einfo 435 elog
322 fi 436 fi
323} 437}
324 438
325vdr-plugin_pkg_postrm() { 439vdr-plugin_pkg_postrm() {
326 remove_vdrplugindb 440 delete_orphan_plugindb_file
327} 441}
328 442
329vdr-plugin_pkg_config_final() {
330 diff ${conf_orig} ${conf}
331 rm ${conf_orig}
332}
333
334vdr-plugin_pkg_config() { 443vdr-plugin_pkg_config_legacy() {
444 elog "Using old interface to gentoo-vdr-scripts-0.3.7"
335 if [[ -z "${INSTALLPLUGIN}" ]]; then 445 if [[ -z "${INSTALLPLUGIN}" ]]; then
336 INSTALLPLUGIN="${VDRPLUGIN}" 446 INSTALLPLUGIN="${VDRPLUGIN}"
337 fi 447 fi
448
449 active=0
338 # First test if plugin is already inside PLUGINS 450 # First test if plugin is already inside PLUGINS
339 local conf=/etc/conf.d/vdr 451 local conf=/etc/conf.d/vdr.plugins
340 conf_orig=${conf}.before_emerge_config 452 exec 3<${conf}
341 cp ${conf} ${conf_orig} 453 while read -u 3 line; do
342 454 [[ ${line} == "" ]] && continue
343 einfo "Reading ${conf}" 455 [[ ${line:0:1} == "#" ]] && continue
344 if ! grep -q "^PLUGINS=" ${conf}; then 456 set -- ${line}
345 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1) 457 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
346 if [[ -n "${LINE}" ]]; then
347 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
348 else
349 echo 'PLUGINS=""' >> ${conf}
350 fi
351 unset LINE
352 fi
353
354 unset PLUGINS
355 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
356
357 active=0
358 for p in ${PLUGINS}; do
359 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
360 active=1
361 break;
362 fi
363 done 458 done
459 exec 3<&-
364 460
365 if [[ "${active}" == "1" ]]; then 461 if [[ $active == 0 ]]; then
462 elog "Adding ${INSTALLPLUGIN} to active plugins."
463
464 # The pure edit process.
465 echo "${INSTALLPLUGIN}" >> "${conf}"
466 else
366 einfo "${INSTALLPLUGIN} already activated" 467 elog "${INSTALLPLUGIN} already activated"
367 echo 468 echo
368 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer 469 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
369 if [[ "${answer}" != "yes" ]]; then 470 if [[ "${answer}" != "yes" ]]; then
370 einfo "aborted" 471 elog "aborted"
371 return 472 return
372 fi 473 fi
373 einfo "Removing ${INSTALLPLUGIN} from active plugins." 474 elog "Removing ${INSTALLPLUGIN} from active plugins."
374 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
375 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
376 -e ${LINE}'s/ \( \)*/ /g' \
377 -e ${LINE}'s/ "/"/g' \
378 -e ${LINE}'s/" /"/g'
379 475
380 vdr-plugin_pkg_config_final 476 # The pure edit process
381 return 477 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
382 fi 478 fi
479}
383 480
384
385 einfo "Adding ${INSTALLPLUGIN} to active plugins."
386 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
387 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
388 -e ${LINE}'s/ \( \)*/ /g' \
389 -e ${LINE}'s/ "/"/g' \
390 -e ${LINE}'s/" /"/g'
391
392 vdr-plugin_pkg_config_final 481vdr-plugin_pkg_config() {
482 ewarn "emerge --config ${PN} is no longer supported"
483 vdr-plugin_print_enable_command
393} 484}
394 485
395fix_vdr_libsi_include() 486fix_vdr_libsi_include()
396{ 487{
397 einfo "Fixing include of libsi-headers" 488 einfo "Fixing include of libsi-headers"

Legend:
Removed from v.1.31  
changed lines
  Added in v.1.54

  ViewVC Help
Powered by ViewVC 1.1.20